<!DOCTYPE html>
<html>
<head>
  <title>Car Parking Roof</title>
  <script src="https://unpkg.com/vue"></script>
</head>
<body>
  <div id="app">
    <div class="row mb-10">
        Parking spots {{ cars }}
    </div>
    <div class="row mb-10">
        At least <span class="text-red fw-600">{{ k }}</span> cars must be covered by the roof
    </div>
    <span class="row mb-10">
        The shortest roof that meets the requirement is of length <span class="text-red fw-600">{{ carParkingRoof() }}</span>
    </div>
  </div>

  <script>
    var app = new Vue({
      el: '#app',
      data: {
        err: 'Invalid parameter',
        cars: [2, 4, 7, 12, 20],
        k: 4
      },

      methods: {

        carParkingRoof() {
            if (!Array.isArray(this.cars)) {return this.err;}
            if (!this.cars.length) {return this.err;}
            if (!parseInt(this.k)) {return this.err;}
            if (this.k > this.cars.length) {return this.err;}
            if (this.k == 1) {return 1;}

            let spotsRange = [];
            for (let i=0;i<this.cars.length;i++) {
                let temp = this.cars.slice(i, this.k + i);
                if (temp.length < this.k) {break;}
                spotsRange[i] = temp; 
            }
            
            let minimum = 0;
            for (let spots of spotsRange) {
                let difference = spots[spots.length-1] - spots[0] + 1;
                if (minimum == 0) {
                    minimum = difference;
                } else {
                    if (difference < minimum) {
                        minimum = difference;   
                    }
                }
            }
            return minimum;
        }
      }
    })
  </script>
</body>
</html>

<style>
    .mb-10 {
        margin-bottom: 10px;
    }
    .text-red {
        color: red;
    }
    .fw-600 {
        font-weight: 600;
    }
</style>
